<template>
  <div class="app-container">
    <el-card>
      <div>
          <el-button type="primary" icon="el-icon-plus" @click="handleCreate"
        >新增标准</el-button >
      <el-input
              v-model="listQuery.search"
              placeholder="标准名称"
              style="width: 300px"
              class="filter-item"
              @keyup.enter.native="handleFilter"
            />
            <el-button
              class="filter-item"
              type="primary"
              icon="el-icon-search"
              @click="handleFilter"
              >搜索</el-button
            >
            <el-button
              class="filter-item"
              type="primary"
              icon="el-icon-refresh-left"
              @click="resetFilter"
              >重置</el-button
            >
    </div>
  
    </el-card>
    <el-card style="margin-top: 2px">
      <el-table
        v-loading="listLoading"
        :data="standardList.results"
        border
        fit
        stripe
        highlight-current-row
        max-height="600"
      >
        <el-table-column type="index" width="50" />
        <el-table-column label="标准名称">
          <template slot-scope="scope">{{ scope.row.name }}</template>
        </el-table-column>
       
        <el-table-column label="标准编号">
          <template slot-scope="scope">{{ scope.row.number }}</template>
        </el-table-column>
           <el-table-column label="是否启用">
          <template slot-scope="scope">
            <el-tag v-if="scope.row.enabled===true">是</el-tag>
             <el-tag v-else>否</el-tag>
          </template>
        </el-table-column>
       <el-table-column label="标准文件">
           <template slot-scope="scope" v-if="scope.row.file_">
            <el-link :href="scope.row.file_.path" >{{scope.row.file_.name}}</el-link>
          </template>
        
        </el-table-column>
        <el-table-column
          align="center"
          label="操作"
          width="220px"
        >
          <template slot-scope="scope">
           
            <el-link
              v-if="checkPermission(['warehouse_update'])"
              @click="handleEdit(scope)"
              >编辑</el-link
            >
            <el-link
              v-if="checkPermission(['warehouse_delete'])"
              type="danger"
              @click="handleDelete(scope)"
              >删除</el-link
            >
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="standardList.count > 0"
        :total="standardList.count"
        :page.sync="listQuery.page"
        :limit.sync="listQuery.page_size"
        @pagination="getList"
      />
    </el-card>
    <el-dialog
      :visible.sync="dialogVisible"
      :title="dialogType === 'edit' ? '编辑标准' : '新增标准'"
    >
      <el-form
        ref="Form"
        :model="standard"
        label-width="80px"
        label-position="right"
        :rules="rule1"
      >
        <el-form-item label="标准名称" prop="name">
          <el-input v-model="standard.name" placeholder="标准名称" />
        </el-form-item>
        <el-form-item label="标准编号" prop="number">
          <el-input v-model="standard.number" placeholder="标准编号" />
        </el-form-item>
        
         <el-form-item label="是否启用" prop="enabled">
          <el-switch v-model="standard.enabled"></el-switch>
        </el-form-item>
          <el-form-item label="指导书" prop="template" v-if="dialogVisible">
          <el-upload
          ref="upload"
          :action="upUrl"
          :on-preview="handlePreview"
          :on-success="handleUpSuccess"
          :on-remove="handleRemove"
          :headers="upHeaders"
          :file-list="fileList"
          :limit="1"
          accept=".doc,.docx,.xls,.xlsx,.ppt,.pptx"
        >
         <el-button size="small" type="primary">上传文件</el-button>
        </el-upload>
        </el-form-item>
        
      </el-form>
      <div style="text-align: right">
        <el-button type="danger" @click="dialogVisible = false">取消</el-button>
        <el-button type="primary" @click="confirm('Form')">确认</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import { getStandardList, createStandard,updateStandard,deleteStandard} from "@/api/qm";
import checkPermission from "@/utils/permission";
import { upUrl, upHeaders } from "@/api/file";

import { genTree } from "@/utils";
import Pagination from "@/components/Pagination"; // secondary package based on el-pagination
const defaultestandard = {
};
export default {
  components: { Pagination },
  data() {
    return {
      standard: defaultestandard,
     contractList: {
        count: 0,
      },
       upHeaders: upHeaders(),
      upUrl: upUrl(),
      fileList:[],
      listQuery: {
        page: 1,
        page_size: 20,
      },
     options:[],
      listLoading: true,
      dialogVisible: false,
      enabled:false,
      dialogType: "new",
      rule1: {
        name: [{ required: true, message: "请输入", trigger: "blur" }],
        number: [{ required: true, message: "请输入", trigger: "blur" }],
      },
    };
  },
  computed: {},
  watch: {},
  created() {
    
    this.getList();
  },
  methods: {
    checkPermission,
  
    getList() {
      this.listLoading = true;
      getStandardList(this.listQuery).then((response) => {
        if (response.data) {
          this.standardList = response.data;
        }
        this.listLoading = false;
      });
    },
   
     handlePreview(file) {
      if ("url" in file) {
        window.open(file.url);
      } else {
        window.open(file.response.data.path);
      }
    },
    handleUpSuccess(res, file, filelist) {
      this.standard.file = res.data.id;
    },
    handleRemove(file, filelist){
      this.standard.file = null;
    },
   
    handleFilter() {
      this.listQuery.page = 1;
      this.getList();
    },
    resetFilter() {
      this.listQuery = {
        page: 1,
        page_size: 20,
      }
      this.getList();
    },
    handleCreate() {
      this.standard = Object.assign({}, defaultestandard);
      this.dialogType = "new";
      this.dialogVisible = true;
       this.fileList=[];
      this.$nextTick(() => {
        this.$refs["Form"].clearValidate();
      });
    },
   
    handleEdit(scope) {
      this.standard = Object.assign({}, scope.row); // copy obj
      this.dialogType = "edit";
      this.dialogVisible = true;
       if (this.standard.file) {
        this.fileList = [
          {
            name:this.standard.file_.name,
            url: this.standard.file_.path,
          },
        ];
      }
      this.$nextTick(() => {
        this.$refs["Form"].clearValidate();
      });
    },
    handleDelete(scope) {
      this.$confirm("确认删除?", "警告", {
        confirmButtonText: "确认",
        cancelButtonText: "取消",
        type: "error",
      })
        .then(async () => {
          await deleteStandard(scope.row.id);
          this.getList();
          this.$message.success("成功");
        })
        .catch((err) => {
          console.error(err);
        });
    },
   
    async confirm(form) {
      this.$refs[form].validate((valid) => {
        if (valid) {
          const isEdit = this.dialogType === "edit";
          if (isEdit) {
            updateStandard(this.standard.id, this.standard).then((res) => {
              if (res.code >= 200) {
                this.getList();
                this.dialogVisible = false;
                this.$message.success("成功");
              }
            });
          } else {
            createStandard(this.standard).then((res) => {
              if (res.code >= 200) {
                this.getList();
                 this.dialogVisible = false;
                this.$message.success("成功");
              }
            });
          }
        } else {
          return false;
        }
      });
    },
  },
};
</script>
